
// #include <Servo.h>
// #include <SoftwareSerial.h>
// #include <Wire.h>
// #include <Adafruit_GFX.h>
// #include <Adafruit_SSD1306.h>

// #define SCREEN_WIDTH 128 // OLED display width, in pixels
// #define SCREEN_HEIGHT 64 // OLED display height, in pixels

// // Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
// #define OLED_RESET -1
// Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

// bool started = false;

// int  enhance_stanga = 0;
// int  enhance_dreapta = 0;

// // motor dreapta
// int enA = 6;
// int in1 = 7;
// int in2 = 8;

// // motor stanga
// int enB = 11;
// int in4 = 10;
// int in3 = 9;

// //senzor de distanta
// int trigPin = 12;
// int echoPin = 13;
// long duration;
// int distance;

// // Servo
// Servo myServo;
// int servoPos = 120;
// int servoLeft = 60;    // Position to look left
// int servoRight = 180;  // Position to look right

// SoftwareSerial bluetooth(4, 3); // RX, TX

// void setup() {
//   // definire pini
//   pinMode(enA, OUTPUT);
//   pinMode(in1, OUTPUT);
//   pinMode(in2, OUTPUT);

//   pinMode(enB, OUTPUT);
//   pinMode(in3, OUTPUT);
//   pinMode(in4, OUTPUT);

//   pinMode(trigPin, OUTPUT);
//   pinMode(echoPin, INPUT);
//   Serial.begin(9600);
//   bluetooth.begin(9600);

//   // setup directie roti motor dreapta
//   digitalWrite(in1, LOW);
//   digitalWrite(in2, HIGH);

//   // setup directie roti motor stanga
//   digitalWrite(in3, HIGH);
//   digitalWrite(in4, LOW);

//   // Attach servo
//   myServo.attach(5);
//   myServo.write(servoPos); // Center the servo

//   // Initialize the display
//   if (!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) {
//     Serial.println(F("SSD1306 allocation failed"));
//     for (;;);
//   }

//   // Clear the buffer
//   display.clearDisplay();
  
//   // Set text color to white
//   display.setTextColor(SSD1306_WHITE);
  
//   // Set text size
//   display.setTextSize(3);
  
//   // Set cursor position to top-left
//   display.setCursor(0, 0);
  
//   // Print "Hello, World!"
//   display.println("Hello, World!");

//   // Display the content on the screen
//   display.display();
// }

// int ia_distanta() {
//   // Clears the trigPin
//   digitalWrite(trigPin, LOW);
//   delayMicroseconds(2);
//   // Sets the trigPin on HIGH state for 10 micro seconds
//   digitalWrite(trigPin, HIGH);
//   delayMicroseconds(10);
//   digitalWrite(trigPin, LOW);
//   // Reads the echoPin, returns the sound wave travel time in microseconds
//   duration = pulseIn(echoPin, HIGH);
//   // Calculating the distance
//   distance = duration * 0.034 / 2;
//   return distance;
// }

// void power_stanga() {
//   analogWrite(enA, 0);
//   analogWrite(enB, 200);
//   delay(100);
//   analogWrite(enB, 150);
// }

// void power_dreapta() {
//   analogWrite(enB, 0);
//   analogWrite(enA, 200);
//   delay(100);
//   analogWrite(enA, 150);
// }

// void normal() {
//   // asa merge drept rotile in fata
//   analogWrite(enA, 150);
//   analogWrite(enB, 150);
// }

// void stop() {
//   analogWrite(enA, 50);
//   analogWrite(enB, 50);
//   delay(200);
//   analogWrite(enA, 0);
//   analogWrite(enB, 0);
// }

// void loop() {

//   if(started == false) {

//     if( bluetooth.available() > 0) {
//       char command = bluetooth.read();
//       Serial.println(command);
//       switch(command) {
//         case 'U':
//           normal();
//           Serial.println(command);
//           started = true;
//           break;

//       }
//     }
//   }
//   if(started == true) {
//     if( bluetooth.available() > 0) {
//       char command = bluetooth.read();
//       switch(command) {
//         case 'U':
//           normal();
//           started = true;
//           break;
//         case '+':
//           stop();
//           Serial.println(command);
//           started = false;
//           break;
//       }
//     }
//   }
//   // put your main code here, to run repeatedly:
//   if(started == true){
//     if (ia_distanta() < 20) {
//       stop();
//       // Look left
//       myServo.write(servoLeft);
//       delay(1000); // Wait for the servo to move and stabilize
//       int distanceLeft = ia_distanta();

//       // Look right
//       myServo.write(servoRight);
//       delay(1000); // Wait for the servo to move and stabilize

//       int distanceRight = ia_distanta();
//           // Decision making based on the measured distances
//       if (distanceLeft > distanceRight) {
//         power_stanga(); // Turn left if the left side is clearer
//       } else {
//         power_dreapta(); // Turn right if the right side is clearer
//       }

//       // Re-center servo
//       myServo.write(servoPos);
//       delay(500); // Wait for the servo to re-center
//     } else {
//       analogWrite(enA, 200);
//       analogWrite(enB, 200);
//       delay(200);
//       normal();
//     }
//   }

// }

#include <Servo.h>
#include <SoftwareSerial.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
#define OLED_RESET -1
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

bool started = false;

int enhance_stanga = 0;
int enhance_dreapta = 0;

// motor dreapta
int enA = 6;
int in1 = 7;
int in2 = 8;

// motor stanga
int enB = 11;
int in4 = 10;
int in3 = 9;

// senzor de distanta
int trigPin = 12;
int echoPin = 13;
volatile unsigned long duration; // Define the duration as volatile since it's modified in ISR
volatile bool echoReceived = false; // Flag to indicate if echo signal has been received
unsigned long startTime; // Time stamp for when the trigger signal is sent
unsigned long stopTime; // Time stamp for when the echo signal is received
int distance;

// Servo
Servo myServo;
int servoPos = 120;
int servoLeft = 60;    // Position to look left
int servoRight = 180;  // Position to look right

SoftwareSerial bluetooth(4, 3); // RX, TX

void setup() {
  // Define pins
  pinMode(enA, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);

  pinMode(enB, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);

  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  Serial.begin(9600);
  bluetooth.begin(9600);

  // Setup motor direction
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);

  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);

  // Attach servo
  myServo.attach(5);
  myServo.write(servoPos); // Center the servo

  // Initialize the display
  if (!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) {
    Serial.println(F("SSD1306 allocation failed"));
    for (;;);
  }

  // Clear the buffer
  display.clearDisplay();

  // Set text color to white
  display.setTextColor(SSD1306_WHITE);

  // Set text size
  display.setTextSize(3);

  // Set cursor position to top-left
  display.setCursor(0, 0);

  // Print "Hello, World!"
  display.println("Hello, World!");

  // Display the content on the screen
  display.display();

  // Attach interrupt to echo pin
  attachInterrupt(digitalPinToInterrupt(echoPin), handleEcho, CHANGE);
}

// Interrupt service routine for handling echo signal
void handleEcho() {
  if (digitalRead(echoPin) == HIGH) {
    startTime = micros(); // Record time stamp when the echo signal starts
  } else {
    stopTime = micros(); // Record time stamp when the echo signal ends
    duration = stopTime - startTime; // Calculate the duration of the echo signal
    echoReceived = true; // Set flag to indicate that the echo signal has been received
  }
}

int ia_distanta() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  // Wait for echo signal to be received
  while (!echoReceived);

  // Calculate distance
  distance = duration * 0.034 / 2;

  // Reset flag
  echoReceived = false;

  return distance;
}

void power_stanga() {
  analogWrite(enA, 0);
  analogWrite(enB, 200);
  delay(100);
  analogWrite(enB, 150);
}

void power_dreapta() {
  analogWrite(enB, 0);
  analogWrite(enA, 200);
  delay(100);
  analogWrite(enA, 150);
}

void normal() {
  // asa merge drept rotile in fata
  analogWrite(enA, 150);
  analogWrite(enB, 150);
}

void stop() {
  analogWrite(enA, 50);
  analogWrite(enB, 50);
  delay(200);
  analogWrite(enA, 0);
  analogWrite(enB, 0);
}
void loop() {

  if(started == false) {

    if( bluetooth.available() > 0) {
      char command = bluetooth.read();
      Serial.println(command);
      switch(command) {
        case 'U':
          normal();
          Serial.println(command);
          started = true;
          break;

      }
    }
  }
  if(started == true) {
    if( bluetooth.available() > 0) {
      char command = bluetooth.read();
      switch(command) {
        case 'U':
          normal();
          started = true;
          break;
        case '+':
          stop();
          Serial.println(command);
          started = false;
          break;
      }
    }
  }
  // put your main code here, to run repeatedly:
  if(started == true){
    if (ia_distanta() < 20) {
      stop();
      // Look left
      myServo.write(servoLeft);
      delay(1000); // Wait for the servo to move and stabilize
      int distanceLeft = ia_distanta();

      // Look right
      myServo.write(servoRight);
      delay(1000); // Wait for the servo to move and stabilize

      int distanceRight = ia_distanta();
          // Decision making based on the measured distances
      if (distanceLeft > distanceRight) {
        power_stanga(); // Turn left if the left side is clearer
      } else {
        power_dreapta(); // Turn right if the right side is clearer
      }

      // Re-center servo
      myServo.write(servoPos);
      delay(500); // Wait for the servo to re-center
    } else {
      analogWrite(enA, 200);
      analogWrite(enB, 200);
      delay(200);
      normal();
    }
  }

}
